#!/usr/bin/env python

# Arc Example Rel 1
# Created by Tin Tran
# Comments directed to http://gimpchat.com or http://gimpscripts.com
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
import math
import string
#import Image
from gimpfu import *
from array import array

def python_arc_example(image, layer,x1,y1,x2,y2) :
	pdb.gimp_image_undo_group_start(image)
	
	
	new_vectors = pdb.gimp_vectors_new(image,"arc example");
	pdb.gimp_image_insert_vectors(image,new_vectors,None,-1);	
	
	control1_1 = [x1,y1] #first control of point 1
	point1 = [x1,y1]     #point 1
	control1_2 = [x1,max(y1,y2) - abs(y2-y1)*0.55191502449] #second control of point 1
	
	control2_1 = [max(x1,x2) - abs(x2-x1)*0.55191502449,y2] #first control of point 2
	point2 = [x2,y2]     #point 2
	control2_2 = [x2,y2] #second control of point 2
	
	all12points = control1_1 + point1 + control1_2 + control2_1 + point2 + control2_2;
	pdb.gimp_vectors_stroke_new_from_points(new_vectors,0,12,all12points,0);
	
	pdb.gimp_item_set_visible(new_vectors,1);
	
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
    #return

register(
    "python_fu_arc_example",
    "Example arc",
    "Example arc",
    "Tin Tran",
    "Tin Tran",
    "2014",
    "<Image>/Python-Fu/Arc Example...",
    "RGB*, GRAY*",      # Create a new image, don't work on an existing one
    [
	(PF_SPINNER, "x1", "x1:", 0, (0, 100, 0.5)),
	(PF_SPINNER, "y1", "y1:", 100, (0, 100, 0.5)),
	(PF_SPINNER, "x2", "x2:", 100, (0, 100, 0.5)),
	(PF_SPINNER, "y2", "y2:", 0, (0, 100, 0.5)),
	#(PF_COLOR, "black",  "Black point color",  (0,0,0) PF_FILE, "infilename", "Temp Filepath", "/Default/Path"),
	#(PF_COLOR, "white",  "White point color",  (255,255,255) ),
	#(PF_COLOR, "gray",  "Gray point color",  (128,128,128) )
	#(PF_FILE, "infilename", "Temp Filepath", "/Default/Path")
	#(PF_DIRNAME, "source_directory", "Source Directory", "") for some reason, on my computer when i(Tin) use PF_DIRNAME the pythonw.exe would crash
	],
    [],
    python_arc_example)

main()
